import { AbstractDirective } from "./abstract-directive";
/**
 * <i data-ng-class="'is-hidden', isHidden"></i>
 */
export class NgClass extends AbstractDirective implements NgTemplate.Directive {
  nodes: NgTemplate.DirectiveNode[];

  static selector: string  = "ng-class";

  constructor( el: HTMLElement, reporter: NgTemplate.Reporter ){
    super( el, reporter );
    this.nodes =  this.initNodes( el, NgClass.selector,
      ( node: HTMLElement, expr: string, compile: Function, cache: NgTemplate.Cache ) => {
      return {
        el: node,
        exp: compile( expr, "__toArray", reporter ),
        cache: cache
      };
    });
  }

  sync( data: NgTemplate.DataMap ){
    this.nodes.forEach(( node: NgTemplate.DirectiveNode ) => {
      node.cache.evaluate( node.exp.call( node.el, data ), ( args: any[] ) => {
        args[ 0 ] && node.el.classList.toggle( args[ 0 ], Boolean( args[ 1 ] ) );
      });
    });
  }
}
